function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var reactHelmet = require('react-helmet');
var reactLanguageSwitch = require('react-language-switch');

var LanguageContext = React.createContext();
function LanguageProvider(_ref) {
  var _json, _json2, _json3, _json4, _json5, _json6, _json7, _jsonData$header, _jsonData$header2;

  var children = _ref.children,
      languages = _ref.languages,
      init = _ref.init,
      defaultTo = _ref.defaultTo,
      json = _ref.json,
      id = _ref.id,
      remember = _ref.remember,
      header = _ref.header;
  var windowGlobal = typeof window !== 'undefined' && window;
  var providerId = id || ((_json = json) === null || _json === void 0 ? void 0 : _json.id) || '';
  var languageList = languages || ((_json2 = json) === null || _json2 === void 0 ? void 0 : _json2.languages) || ['en'];
  var initialLanguage = init || ((_json3 = json) === null || _json3 === void 0 ? void 0 : _json3.init) || 'en';
  var content = ((_json4 = json) === null || _json4 === void 0 ? void 0 : _json4.content) || {};
  remember = remember ? true : (_json5 = json) !== null && _json5 !== void 0 && _json5.remember ? json.remember : false;
  header = header || ((_json6 = json) === null || _json6 === void 0 ? void 0 : _json6.header) || {};
  defaultTo = defaultTo || ((_json7 = json) === null || _json7 === void 0 ? void 0 : _json7.defaultTo) || initialLanguage;
  json = {
    id: providerId,
    languages: languageList,
    init: initialLanguage,
    defaultTo: defaultTo,
    remember: remember,
    content: content,
    header: header
  };

  var _useState = React.useState(initialLanguage),
      lang = _useState[0],
      setLanguage = _useState[1];

  var _useState2 = React.useState(json),
      jsonData = _useState2[0],
      setJsonData = _useState2[1];

  var language = function language() {
    return lang;
  };

  var localId = function localId() {
    return "lang-" + (providerId ? providerId : 0);
  };

  React.useEffect(function () {
    if (remember) {
      var initFromLocal = windowGlobal.localStorage.getItem(localId());
      if (initFromLocal) setLanguage(initFromLocal);
    }

    windowGlobal.sessionStorage.setItem(localId() + "-json", JSON.stringify(jsonData));
  }, []);
  React.useEffect(function () {
    if (remember) windowGlobal.localStorage.setItem(localId(), lang);
    windowGlobal.sessionStorage.setItem(localId(), lang);
    windowGlobal.sessionStorage.setItem(localId() + "-json", JSON.stringify(jsonData));
    windowGlobal.dispatchEvent(new Event("storage"));
  }, [lang]);

  var updateLang = function updateLang() {
    var lang_in = windowGlobal.sessionStorage.getItem(localId());
    var json_in = JSON.parse(windowGlobal.sessionStorage.getItem(localId() + "-json"));
    setLanguage(lang_in);
    setJsonData(json_in);
  };

  React.useEffect(function () {
    windowGlobal.addEventListener('storage', updateLang);
    return function () {
      windowGlobal.removeEventListener('storage', updateLang);
    };
  }, []);
  return /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(reactHelmet.Helmet, null, jsonData !== null && jsonData !== void 0 && (_jsonData$header = jsonData.header) !== null && _jsonData$header !== void 0 && _jsonData$header.title ? /*#__PURE__*/React__default.createElement("title", null, jsonData.header.title[language()]) : null, jsonData !== null && jsonData !== void 0 && (_jsonData$header2 = jsonData.header) !== null && _jsonData$header2 !== void 0 && _jsonData$header2.meta ? jsonData.header.meta.map(function (metaObj) {
    var useLang = null;
    Object.keys(metaObj).forEach(function (key) {
      if (key === language()) useLang = key;
    });
    if (!useLang) useLang = defaultTo;
    return /*#__PURE__*/React__default.createElement("meta", {
      key: metaObj.name,
      name: metaObj.name,
      content: metaObj[useLang]
    });
  }) : null), /*#__PURE__*/React__default.createElement(LanguageContext.Provider, {
    value: {
      language: language,
      setLanguage: setLanguage,
      defaultTo: jsonData === null || jsonData === void 0 ? void 0 : jsonData.defaultTo,
      initialLanguage: jsonData === null || jsonData === void 0 ? void 0 : jsonData.init,
      languageList: jsonData === null || jsonData === void 0 ? void 0 : jsonData.languages,
      content: jsonData === null || jsonData === void 0 ? void 0 : jsonData.content,
      providerId: jsonData === null || jsonData === void 0 ? void 0 : jsonData.id,
      remember: jsonData === null || jsonData === void 0 ? void 0 : jsonData.remember,
      header: jsonData === null || jsonData === void 0 ? void 0 : jsonData.header
    }
  }, children));
}

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function LanguageDisplay(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React__default.createElement(LanguageContext.Consumer, null, function (langVal) {
    if (!children) return;
    if (!children.length) children = [children];
    var out = [];
    var useLang = null;

    for (var _iterator = _createForOfIteratorHelperLoose(children), _step; !(_step = _iterator()).done;) {
      var tag = _step.value;
      if (langVal.language() === tag.type) useLang = langVal.language();
    }

    if (!useLang) useLang = langVal.defaultTo;
    var i = 0;

    for (var _iterator2 = _createForOfIteratorHelperLoose(children), _step2; !(_step2 = _iterator2()).done;) {
      var _tag = _step2.value;

      if (langVal.languageList.includes(_tag.type)) {
        if (useLang === _tag.type) out.push( /*#__PURE__*/React__default.createElement("span", {
          key: i
        }, _tag.props.children));
      } else {
        if (typeof _tag === "object" && _tag.type !== "br") {
          var elem = React__default.createElement(_tag.type, _extends({
            key: i
          }, _tag.props), /*#__PURE__*/React__default.createElement(LanguageDisplay, null, _tag.props.children));
          out.push(elem);
        } else {
          out.push(_tag);
        }
      }

      i++;
    }

    return out;
  });
}
function LanguageSelect(_ref2) {
  var children = _ref2.children;
  return /*#__PURE__*/React__default.createElement(LanguageContext.Consumer, null, function (langVal) {
    if (!children) return;
    if (!children.length) children = [children];
    var out = [];
    var i = 0;

    var _loop = function _loop() {
      var tag = _step3.value;

      if (langVal.languageList.includes(tag.type)) {
        out.push( /*#__PURE__*/React__default.createElement("span", {
          key: i,
          onClick: function onClick() {
            return langVal.setLanguage(tag.type);
          }
        }, tag.props.children));
      } else {
        if (typeof tag === "object" && tag.type !== "br") {
          var elem = React__default.createElement(tag.type, _extends({
            key: i
          }, tag.props), /*#__PURE__*/React__default.createElement(LanguageSelect, null, tag.props.children));
          out.push(elem);
        } else {
          out.push(tag);
        }
      }

      i++;
    };

    for (var _iterator3 = _createForOfIteratorHelperLoose(children), _step3; !(_step3 = _iterator3()).done;) {
      _loop();
    }

    return out;
  });
}

function LanguageText(_ref) {
  var name = _ref.name;
  if (!name) throw 'The LanguageText component requires a "name" property corresponding to a key in your content object.';
  return /*#__PURE__*/React__default.createElement(reactLanguageSwitch.LanguageContext.Consumer, null, function (langVal) {
    var out = langVal === null || langVal === void 0 ? void 0 : langVal.content[name][langVal.language()];
    if (!out) out = langVal === null || langVal === void 0 ? void 0 : langVal.content[name][langVal.defaultTo];
    return out;
  });
}

function useLanguage(id) {
  var windowGlobal = typeof window !== 'undefined' && window;

  var _useState = React.useState(null),
      lang = _useState[0],
      setLang = _useState[1];

  var _useState2 = React.useState(null),
      json = _useState2[0],
      setJson = _useState2[1];

  var updateLang = function updateLang() {
    var lang_in = windowGlobal.sessionStorage.getItem("lang-" + (id ? id : 0));
    var json_in = JSON.parse(windowGlobal.sessionStorage.getItem("lang-" + (id ? id : 0) + "-json"));
    if (lang_in !== lang) setLang(lang_in);
    if (JSON.stringify(json_in) === JSON.stringify(json)) setJson(json_in);
  };

  React.useEffect(function () {
    if (lang !== null) windowGlobal.sessionStorage.setItem("lang-" + (id ? id : 0), lang);
    if (json !== null) windowGlobal.sessionStorage.setItem("lang-" + (id ? id : 0) + "-json", JSON.stringify(json));
    windowGlobal.dispatchEvent(new Event('storage'));
  }, [lang, json]);
  React.useEffect(function () {
    if (lang == null) setLang(windowGlobal.sessionStorage.getItem("lang-" + (id ? id : 0)));
    windowGlobal.addEventListener('storage', updateLang);
    return function () {
      windowGlobal.removeEventListener('storage', updateLang);
    };
  }, [lang, json]);

  var getContent = function getContent(name) {
    var _windowGlobal$session;

    var useJson = _extends({}, json);

    if (json == null) useJson = JSON.parse(((_windowGlobal$session = windowGlobal.sessionStorage) === null || _windowGlobal$session === void 0 ? void 0 : _windowGlobal$session.getItem("lang-" + (id ? id : 0) + "-json")) || "null");
    if (useJson == null) return "";
    if (!useJson.content[name]) return "undefined";
    var out = useJson.content[name][lang];
    if (!out) out = useJson.content[name][useJson.defaultTo];
    return out;
  };

  var setContent = function setContent(name, val) {
    var _windowGlobal$session2;

    var newJson = _extends({}, json);

    if (json == null) newJson = JSON.parse(((_windowGlobal$session2 = windowGlobal.sessionStorage) === null || _windowGlobal$session2 === void 0 ? void 0 : _windowGlobal$session2.getItem("lang-" + (id ? id : 0) + "-json")) || "null");
    if (newJson == null) return;
    newJson.content[name] = val;
    setJson(newJson);
  };

  return {
    get: function get() {
      return lang;
    },
    set: setLang,
    getContent: getContent,
    setContent: setContent
  };
}

exports.LanguageContext = LanguageContext;
exports.LanguageDisplay = LanguageDisplay;
exports.LanguageSelect = LanguageSelect;
exports.LanguageText = LanguageText;
exports.default = LanguageProvider;
exports.useLanguage = useLanguage;
//# sourceMappingURL=index.js.map
